<template>
  <div>
    <a
      v-if="type === 'group'"
      :href="
        contentOnOwnInstanceURL(actor.url, userInstance.instanceRedirectURI)
      "
      rel="nofollow noreferrer noopener"
      target="_blank"
      class="flex items-start gap-2 hover:underline max-w-xs lg:max-w-lg xl:max-w-xl"
      :title="$gettext('Go on this group page')"
    >
      <img
        class="w-10 h-10 rounded-full shadow-lg"
        :src="defaultAvatarURL || avatarWithDefault"
        alt=""
        :class="{ account: isAccount }"
        @error="setAvatarToDefault()"
      />

      <p class="flex flex-col text-ellipsis overflow-hidden">
        <strong :class="{ 'line-clamp-1': minimal }">{{
          actor.displayName
        }}</strong>

        <span class="actor-handle truncate">
          {{ actor.name }}@{{ actor.host }}
        </span>
      </p>
    </a>
    <div v-else class="flex items-start gap-2 max-w-xs lg:max-w-lg xl:max-w-xl">
      <img
        class="w-10 h-10 rounded-full shadow-lg"
        :src="defaultAvatarURL || avatarWithDefault"
        alt=""
        :class="{ account: isAccount }"
        @error="setAvatarToDefault()"
      />

      <p class="flex flex-col text-ellipsis overflow-hidden" v-if="actor">
        <strong :class="{ 'line-clamp-1': minimal }" v-if="actor.displayName">{{
          actor.displayName
        }}</strong>

        <span class="actor-handle truncate">
          {{ federatedUsername }}
        </span>
      </p>
    </div>
  </div>
</template>

<script setup lang="ts">
  import { ref, computed, inject } from 'vue'
  import { Actor } from '../../../server/types/actor.model'
  import { UserInstanceData } from '../../../shared/remote-instance'
  import { contentOnOwnInstanceURL } from '../plugins/preferredInstance'

  const props = withDefaults(
    defineProps<{
      actor: Actor
      type: 'group' | 'account'
      minimal?: boolean
    }>(),
    {
      minimal: false,
    }
  )

  const isAccount = computed<boolean>(() => props.type === 'account')
  const federatedUsername = computed(() => {
    if (props.actor) {
      return `${props.actor.name}@${props.actor.host}`
    }
    return null
  })
  const avatarWithDefault = computed(
    () => props.actor?.avatar || fallbackAvatarURL.value
  )

  const fallbackAvatarURL = computed(
    () =>
      `https://avatars.joinmobilizon.org/avatar.php?seed=${encodeURIComponent(
        federatedUsername.value
      )}`
  )

  const defaultAvatarURL = ref<string>(null)

  function setAvatarToDefault() {
    defaultAvatarURL.value = fallbackAvatarURL.value
  }

  const userInstance = inject<UserInstanceData>('userInstance')
</script>
